Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/src/Commit_unit_transition.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/src/Commit_unit_transition.cpp	(revision 121)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/src/Commit_unit_transition.cpp	(revision 122)
@@ -16,5 +16,4 @@
 namespace ooo_engine {
 namespace commit_unit {
-
   
 #undef  FUNCTION
@@ -41,4 +40,5 @@
 	reg_NUM_BANK_HEAD = 0;
 	reg_NUM_BANK_TAIL = 0;
+        reg_NUM_PTR_TAIL  = 0;
 
         // Reset counter
@@ -51,7 +51,8 @@
 	      reg_NB_INST_COMMIT_MEM    [i][j] = 0;
                                         
-              reg_EVENT_STATE           [i][j] = EVENT_STATE_NO_EVENT;
-              reg_EVENT_FLUSH           [i][j] = false;
+              reg_EVENT_STATE           [i][j] = COMMIT_EVENT_STATE_NO_EVENT;
+//            reg_EVENT_FLUSH           [i][j] = false;
               reg_EVENT_STOP            [i][j] = false;
+              reg_EVENT_LAST            [i][j] = false;
 
 //            reg_PC_PREVIOUS           [i][j] = (0x100-4)>>2;
@@ -80,169 +81,246 @@
 	for (uint32_t i=0; i<_param->_nb_front_end; i++)
 	  for (uint32_t j=0; j<_param->_nb_context [i]; j++)
-            switch (reg_EVENT_STATE [i][j])
-              {
-              case EVENT_STATE_EVENT    : 
+            {
+              // Test if can_restart : (can_restart is to signal at the state than the decod_queue is empty)
+              //   *     no previous can_restart (trap for one)
+              //   * and decod_queue is empty
+              //   * and have an event or have a futur event
+              if (not reg_EVENT_CAN_RESTART [i][j] and
+                   (PORT_READ(in_NB_INST_DECOD_ALL [i][j]) == 0) and
+                   (reg_EVENT_STOP [i][j] or (reg_EVENT_STATE [i][j] != COMMIT_EVENT_STATE_NO_EVENT)))
+                reg_EVENT_CAN_RESTART [i][j] = true;
+
+              // Test event state
+              switch (reg_EVENT_STATE [i][j])
                 {
-                  if (internal_RETIRE_EVENT_VAL [i][j] and in_RETIRE_EVENT_ACK [i][j])
-                    reg_EVENT_STATE [i][j] = EVENT_STATE_WAITEND ; 
-                  break;
+                case COMMIT_EVENT_STATE_EVENT    : 
+                  {
+                    // Have an event, test if all composant have ack
+                    if (internal_RETIRE_EVENT_VAL [i][j] and in_RETIRE_EVENT_ACK [i][j])
+                      {
+                        // A minor optimisation : test if wait_decod is previously empty.
+                        if (not reg_EVENT_CAN_RESTART [i][j])
+                          reg_EVENT_STATE [i][j] = COMMIT_EVENT_STATE_WAIT_DECOD;
+                        else
+                          reg_EVENT_STATE [i][j] = COMMIT_EVENT_STATE_WAIT_END; 
+                      }
+                    
+                    break;
+                  }
+                case COMMIT_EVENT_STATE_WAIT_DECOD : 
+                  {
+                    // Wait flush of decod_queue.
+                    // Test if can restart now
+                    if (reg_EVENT_CAN_RESTART [i][j])
+                      {
+                        //reg_EVENT_FLUSH [i][j] = false;
+
+                        // A minor optimisation : test if the last element is already retire
+                        if (not reg_EVENT_LAST [i][j])
+                          reg_EVENT_STATE [i][j] = COMMIT_EVENT_STATE_WAIT_END;
+                        else
+                          reg_EVENT_STATE [i][j] = COMMIT_EVENT_STATE_END; 
+                      }
+                    break;
+                  }
+                case COMMIT_EVENT_STATE_WAIT_END : 
+                  {
+                    // Wait the flush of Re Order Buffer.
+                    // Test if the last element is retire
+                    if (reg_EVENT_LAST [i][j])
+                      reg_EVENT_STATE [i][j] = COMMIT_EVENT_STATE_END ; 
+                    
+                    break;
+                  }
+                case COMMIT_EVENT_STATE_END      :
+                  {
+                    // Just one cycle
+                    
+                    // flush of re order buffer is finish
+                    reg_EVENT_STATE [i][j] = COMMIT_EVENT_STATE_NO_EVENT;
+                    reg_EVENT_LAST  [i][j] = false;
+                    break;
+                  }
+                  //case COMMIT_EVENT_STATE_NO_EVENT : 
+                default : break;
                 }
-              case EVENT_STATE_WAITEND  : 
+            }
+
+	// ===================================================================
+	// =====[ INSERT ]====================================================
+	// ===================================================================
+        {
+          // variable to count instruction insert
+          uint32_t nb_insert = 0;
+
+          for (uint32_t i=0; i<_param->_nb_bank; i++)
+            {
+              // compute first bank number
+              uint32_t num_bank = (reg_NUM_BANK_TAIL+i)%_param->_nb_bank;
+              
+              if (internal_BANK_INSERT_VAL [num_bank])
                 {
-                  Tcounter_t nb_inst_all = PORT_READ(in_NB_INST_DECOD_ALL [i][j]) + reg_NB_INST_COMMIT_ALL [i][j];
-                  if (nb_inst_all == 0)
+                  // get rename unit source and instruction.
+                  uint32_t x = internal_BANK_INSERT_NUM_RENAME_UNIT [num_bank];
+                  uint32_t y = internal_BANK_INSERT_NUM_INST        [num_bank];
+                  
+                  // Test if an instruction is valid
+                  // (all in_order insert combinatory is in rename_unit )
+                  if (PORT_READ(in_INSERT_VAL [x][y]))
                     {
-                      reg_EVENT_STATE [i][j] = EVENT_STATE_END;
-                      reg_EVENT_FLUSH [i][j] = false;
-                      //reg_EVENT_STOP  [i][j] = false;
+                      log_printf(TRACE,Commit_unit,FUNCTION,"  * INSERT            [%d][%d]",x,y);
+                      
+                      // get information
+                      Tcontext_t   front_end_id = (_param->_have_port_front_end_id)?PORT_READ(in_INSERT_FRONT_END_ID [x][y]):0;
+                      Tcontext_t   context_id   = (_param->_have_port_context_id  )?PORT_READ(in_INSERT_CONTEXT_ID   [x][y]):0;
+                      Ttype_t      type         = PORT_READ(in_INSERT_TYPE         [x][y]);
+                      Toperation_t operation    = PORT_READ(in_INSERT_OPERATION    [x][y]);
+                      bool         is_store     = is_operation_memory_store(operation);
+                      
+                      Texception_t exception    = PORT_READ(in_INSERT_EXCEPTION    [x][y]);
+                      Tcontrol_t   no_execute   = PORT_READ(in_INSERT_NO_EXECUTE   [x][y]);
+                      
+                      log_printf(TRACE,Commit_unit,FUNCTION,"    * front_end_id   : %d",front_end_id);
+                      log_printf(TRACE,Commit_unit,FUNCTION,"    * context_id     : %d",context_id);
+                      log_printf(TRACE,Commit_unit,FUNCTION,"    * type           : %s",toString(type).c_str());
+                      log_printf(TRACE,Commit_unit,FUNCTION,"    * operation      : %d",operation );
+                      log_printf(TRACE,Commit_unit,FUNCTION,"    * exception      : %d",exception );
+                      
+                      // Create new entry and write information
+                      entry_t * entry = new entry_t;
+                      uint32_t  ptr   = reg_BANK_PTR [num_bank];
+
+	              entry->ptr                     = ptr;
+	              entry->front_end_id            = front_end_id;
+	              entry->context_id              = context_id  ;
+	              entry->rename_unit_id          = x;
+	              entry->depth                   = (_param->_have_port_depth)?PORT_READ(in_INSERT_DEPTH [x][y]):0;
+	              entry->type                    = type;
+	              entry->operation               = operation;
+	              entry->is_delay_slot           = PORT_READ(in_INSERT_IS_DELAY_SLOT         [x][y]);
+// 	              entry->address                 = PORT_READ(in_INSERT_ADDRESS               [x][y]);
+	              entry->exception               = exception;
+	              entry->exception_use           = PORT_READ(in_INSERT_EXCEPTION_USE         [x][y]);
+	              entry->use_store_queue         = (type == TYPE_MEMORY) and (    is_store) and (not no_execute);
+	              entry->use_load_queue          = (type == TYPE_MEMORY) and (not is_store) and (not no_execute);
+	              entry->store_queue_ptr_write   = PORT_READ(in_INSERT_STORE_QUEUE_PTR_WRITE [x][y]);
+	              entry->load_queue_ptr_write    = (_param->_have_port_load_queue_ptr)?PORT_READ(in_INSERT_LOAD_QUEUE_PTR_WRITE [x][y]):0;
+#ifdef DEBUG        
+	              entry->read_ra                 = PORT_READ(in_INSERT_READ_RA               [x][y]);
+	              entry->num_reg_ra_log          = PORT_READ(in_INSERT_NUM_REG_RA_LOG        [x][y]);
+	              entry->num_reg_ra_phy          = PORT_READ(in_INSERT_NUM_REG_RA_PHY        [x][y]);
+	              entry->read_rb                 = PORT_READ(in_INSERT_READ_RB               [x][y]);
+	              entry->num_reg_rb_log          = PORT_READ(in_INSERT_NUM_REG_RB_LOG        [x][y]);
+	              entry->num_reg_rb_phy          = PORT_READ(in_INSERT_NUM_REG_RB_PHY        [x][y]);
+	              entry->read_rc                 = PORT_READ(in_INSERT_READ_RC               [x][y]);
+	              entry->num_reg_rc_log          = PORT_READ(in_INSERT_NUM_REG_RC_LOG        [x][y]);
+	              entry->num_reg_rc_phy          = PORT_READ(in_INSERT_NUM_REG_RC_PHY        [x][y]);
+#endif                
+	              entry->write_rd                = PORT_READ(in_INSERT_WRITE_RD              [x][y]);
+	              entry->num_reg_rd_log          = PORT_READ(in_INSERT_NUM_REG_RD_LOG        [x][y]);
+	              entry->num_reg_rd_phy_old      = PORT_READ(in_INSERT_NUM_REG_RD_PHY_OLD    [x][y]);
+	              entry->num_reg_rd_phy_new      = PORT_READ(in_INSERT_NUM_REG_RD_PHY_NEW    [x][y]);
+	              entry->write_re                = PORT_READ(in_INSERT_WRITE_RE              [x][y]);
+	              entry->num_reg_re_log          = PORT_READ(in_INSERT_NUM_REG_RE_LOG        [x][y]);
+	              entry->num_reg_re_phy_old      = PORT_READ(in_INSERT_NUM_REG_RE_PHY_OLD    [x][y]);
+	              entry->num_reg_re_phy_new      = PORT_READ(in_INSERT_NUM_REG_RE_PHY_NEW    [x][y]);
+                      entry->no_sequence             = type == TYPE_BRANCH;
+                      entry->speculative             = true;
+#ifdef DEBUG        
+	              entry->address                 = PORT_READ(in_INSERT_ADDRESS               [x][y]);
+#endif                
+	              entry->address_next            = PORT_READ(in_INSERT_ADDRESS_NEXT          [x][y]);
+#ifdef DEBUG        
+                      entry->cycle_rob_in            = simulation_cycle();
+                      entry->cycle_commit            = simulation_cycle();
+#endif      
+            
+                      // Test if exception :
+                      //  * yes : no execute instruction, wait ROB Head
+                      //  * no  : test if no_execute (== instruction is flushed)
+                      //          else test type
+                      //            * BRANCH : l.j   -> branch is ended
+                      //                       other -> wait the execution end of branchment
+                      //            * MEMORY : store -> wait store is at head of ROB
+                      //                       other -> wait end of instruction
+                      //            * OTHER
+            
+                      {
+                        if (exception == EXCEPTION_NONE)
+                          {
+                            // no_execute : l.j, l.nop, l.rfe
+                            
+                            log_printf(TRACE,Commit_unit,FUNCTION,"    * no_execute     : %d",no_execute);
+                            
+                            switch (type)
+                              {
+                              case TYPE_BRANCH : {entry->state=(no_execute==1)?ROB_BRANCH_COMPLETE:ROB_BRANCH_WAIT_END  ; break;}
+                              case TYPE_MEMORY : {entry->state=(no_execute==1)?ROB_END_OK_SPECULATIVE:(entry->state=(is_store  ==1)?ROB_STORE_WAIT_END_OK:ROB_OTHER_WAIT_END); break;}
+                              default          : {entry->state=(no_execute==1)?ROB_END_OK_SPECULATIVE:ROB_OTHER_WAIT_END; break;}
+                              }
+                          }
+                        else
+                          {
+                            // Have an exception : wait head of ROB
+                            // in_INSERT_NO_EXECUTE [x][y] : l.sys, l.trap
+                            
+                            entry->state = ROB_END_EXCEPTION_WAIT_HEAD;
+                          }
+                      }
+
+#ifdef STATISTICS
+                      if (usage_is_set(_usage,USE_STATISTICS))
+                        (*_stat_nb_inst_insert [x]) ++;
+#endif
+                    
+                      // Push entry in rob
+                      _rob[num_bank].push_back(entry);
+                      
+                      // Update counter and pointer
+                      reg_NB_INST_COMMIT_ALL [front_end_id][context_id] ++;
+                      if (type == TYPE_MEMORY)
+                        reg_NB_INST_COMMIT_MEM [front_end_id][context_id] ++;
+                      
+
+                      // flush = present event or future event.
+                      //  * present event = don't can restart
+
+//                       bool flush = reg_EVENT_FLUSH [front_end_id][context_id];
+
+//                       bool flush = (((reg_EVENT_STATE [front_end_id][context_id] == COMMIT_EVENT_STATE_EVENT) or
+//                                      (reg_EVENT_STATE [front_end_id][context_id] == COMMIT_EVENT_STATE_WAIT_DECOD)) or
+//                                     (reg_EVENT_STOP [front_end_id][context_id]));
+                      
+                      // New instruction from decod_queue. Flush if :
+                      //     * future event (instruction don't need execute because they are a previous event (miss load/branch or exception))
+                      //     * or present_event 
+                      //   * and not can_restart (previous empty decod queue), because between the event_stop (branch_complete) and the state event (miss in head), many cycle is occured.
+                      bool flush = ((// present event
+                                     ((reg_EVENT_STATE [front_end_id][context_id] == COMMIT_EVENT_STATE_EVENT) or
+                                      (reg_EVENT_STATE [front_end_id][context_id] == COMMIT_EVENT_STATE_WAIT_DECOD)) or
+                                     // futur event
+                                     reg_EVENT_STOP [front_end_id][context_id])
+                                    // can't restart
+                                    and not reg_EVENT_CAN_RESTART[front_end_id][context_id]
+                                    );
+
+                      if (flush)
+                        {
+                          // A new invalid instruction is push in rob -> new last instruction
+                          reg_EVENT_LAST          [front_end_id][context_id] = false;
+                          reg_EVENT_LAST_NUM_BANK [front_end_id][context_id] = num_bank;
+                          reg_EVENT_LAST_NUM_PTR  [front_end_id][context_id] = ptr;
+                        }
+                      
+                      // Update pointer
+                      reg_NUM_PTR_TAIL  = ptr;
+                      reg_BANK_PTR [num_bank]  = (reg_BANK_PTR [num_bank]+1)%_param->_size_bank;
+                      nb_insert ++;
                     }
-                  break;
                 }
-              case EVENT_STATE_END      :
-                {
-                  reg_EVENT_STATE [i][j] = EVENT_STATE_NO_EVENT;
-                  break;
-                }
-//            case EVENT_STATE_NO_EVENT : 
-              default : break;
-              }
-
-	// ===================================================================
-	// =====[ INSERT ]====================================================
-	// ===================================================================
-	for (uint32_t i=0; i<_param->_nb_bank; i++)
-	  if (internal_BANK_INSERT_VAL [i])
-	    {
-              // get rename unit source and instruction.
-	      uint32_t x = internal_BANK_INSERT_NUM_RENAME_UNIT [i];
-	      uint32_t y = internal_BANK_INSERT_NUM_INST        [i];
-
-	      if (PORT_READ(in_INSERT_VAL [x][y]))
-		{
-		  log_printf(TRACE,Commit_unit,FUNCTION,"  * INSERT            [%d][%d]",x,y);
-
-                  // get information
-		  Tcontext_t   front_end_id = (_param->_have_port_front_end_id)?PORT_READ(in_INSERT_FRONT_END_ID [x][y]):0;
-		  Tcontext_t   context_id   = (_param->_have_port_context_id  )?PORT_READ(in_INSERT_CONTEXT_ID   [x][y]):0;
-		  Ttype_t      type         = PORT_READ(in_INSERT_TYPE         [x][y]);
-                  Toperation_t operation    = PORT_READ(in_INSERT_OPERATION    [x][y]);
-                  bool         is_store     = is_operation_memory_store(operation);
-
-		  Texception_t exception    = PORT_READ(in_INSERT_EXCEPTION    [x][y]);
-		  Tcontrol_t   no_execute   = PORT_READ(in_INSERT_NO_EXECUTE   [x][y]);
-
-		  log_printf(TRACE,Commit_unit,FUNCTION,"    * front_end_id   : %d",front_end_id);
-		  log_printf(TRACE,Commit_unit,FUNCTION,"    * context_id     : %d",context_id);
-		  log_printf(TRACE,Commit_unit,FUNCTION,"    * type           : %s",toString(type).c_str());
-		  log_printf(TRACE,Commit_unit,FUNCTION,"    * operation      : %d",operation );
-		  log_printf(TRACE,Commit_unit,FUNCTION,"    * exception      : %d",exception );
-                  
-                  // Create new entry.
-		  entry_t * entry = new entry_t;
-
-		  entry->ptr                     = reg_BANK_PTR [i];
-		  entry->front_end_id            = front_end_id;
-		  entry->context_id              = context_id  ;
-		  entry->rename_unit_id          = x;
-		  entry->depth                   = (_param->_have_port_depth)?PORT_READ(in_INSERT_DEPTH [x][y]):0;
-		  entry->type                    = type;
-		  entry->operation               = operation;
-		  entry->is_delay_slot           = PORT_READ(in_INSERT_IS_DELAY_SLOT         [x][y]);
-// 		  entry->address                 = PORT_READ(in_INSERT_ADDRESS               [x][y]);
-		  entry->exception               = exception;
-		  entry->exception_use           = PORT_READ(in_INSERT_EXCEPTION_USE         [x][y]);
-		  entry->use_store_queue         = (type == TYPE_MEMORY) and (    is_store) and (not no_execute);
-		  entry->use_load_queue          = (type == TYPE_MEMORY) and (not is_store) and (not no_execute);
-		  entry->store_queue_ptr_write   = PORT_READ(in_INSERT_STORE_QUEUE_PTR_WRITE [x][y]);
-		  entry->load_queue_ptr_write    = (_param->_have_port_load_queue_ptr)?PORT_READ(in_INSERT_LOAD_QUEUE_PTR_WRITE [x][y]):0;
-#ifdef DEBUG
-		  entry->read_ra                 = PORT_READ(in_INSERT_READ_RA               [x][y]);
-		  entry->num_reg_ra_log          = PORT_READ(in_INSERT_NUM_REG_RA_LOG        [x][y]);
-		  entry->num_reg_ra_phy          = PORT_READ(in_INSERT_NUM_REG_RA_PHY        [x][y]);
-		  entry->read_rb                 = PORT_READ(in_INSERT_READ_RB               [x][y]);
-		  entry->num_reg_rb_log          = PORT_READ(in_INSERT_NUM_REG_RB_LOG        [x][y]);
-		  entry->num_reg_rb_phy          = PORT_READ(in_INSERT_NUM_REG_RB_PHY        [x][y]);
-		  entry->read_rc                 = PORT_READ(in_INSERT_READ_RC               [x][y]);
-		  entry->num_reg_rc_log          = PORT_READ(in_INSERT_NUM_REG_RC_LOG        [x][y]);
-		  entry->num_reg_rc_phy          = PORT_READ(in_INSERT_NUM_REG_RC_PHY        [x][y]);
-#endif
-		  entry->write_rd                = PORT_READ(in_INSERT_WRITE_RD              [x][y]);
-		  entry->num_reg_rd_log          = PORT_READ(in_INSERT_NUM_REG_RD_LOG        [x][y]);
-		  entry->num_reg_rd_phy_old      = PORT_READ(in_INSERT_NUM_REG_RD_PHY_OLD    [x][y]);
-		  entry->num_reg_rd_phy_new      = PORT_READ(in_INSERT_NUM_REG_RD_PHY_NEW    [x][y]);
-		  entry->write_re                = PORT_READ(in_INSERT_WRITE_RE              [x][y]);
-		  entry->num_reg_re_log          = PORT_READ(in_INSERT_NUM_REG_RE_LOG        [x][y]);
-		  entry->num_reg_re_phy_old      = PORT_READ(in_INSERT_NUM_REG_RE_PHY_OLD    [x][y]);
-		  entry->num_reg_re_phy_new      = PORT_READ(in_INSERT_NUM_REG_RE_PHY_NEW    [x][y]);
-                  entry->no_sequence             = type == TYPE_BRANCH;
-                  entry->speculative             = true;
-#ifdef DEBUG
-		  entry->address                 = PORT_READ(in_INSERT_ADDRESS               [x][y]);
-#endif
-		  entry->address_next            = PORT_READ(in_INSERT_ADDRESS_NEXT          [x][y]);
-#ifdef DEBUG
-                  entry->cycle_rob_in            = simulation_cycle();
-                  entry->cycle_commit            = simulation_cycle();
-#endif
-
-                  // Test if exception :
-                  //  * yes : no execute instruction, wait ROB Head
-                  //  * no  : test type
-                  //            * BRANCH : l.j   -> branch is ended
-                  //                       other -> wait the execution end of branchment
-                  //            * MEMORY : store -> wait store is at head of ROB
-                  //                       other -> wait end of instruction
-                  //            * OTHER
-
-//                   bool       flush      = reg_EVENT_FLUSH [front_end_id][context_id];
-
-//                   log_printf(TRACE,Commit_unit,FUNCTION,"    * flush          : %d",flush);
-
-//                   if (flush)
-//                     {
-//                       entry->state    = ROB_END_MISS; // All type (branch, memory and others), because, is not execute
-//                     }
-//                   else
-                    {
-                      if (exception == EXCEPTION_NONE)
-                        {
-                          // no_execute : l.j, l.nop, l.rfe
-                          
-                          log_printf(TRACE,Commit_unit,FUNCTION,"    * no_execute     : %d",no_execute);
-                          
-                          switch (type)
-                            {
-                            case TYPE_BRANCH : {entry->state=(no_execute==1)?ROB_BRANCH_COMPLETE:ROB_BRANCH_WAIT_END  ; break;}
-                            case TYPE_MEMORY : {entry->state=(no_execute==1)?ROB_END_OK_SPECULATIVE:(entry->state=(is_store  ==1)?ROB_STORE_WAIT_HEAD_OK:ROB_OTHER_WAIT_END); break;}
-                            default          : {entry->state=(no_execute==1)?ROB_END_OK_SPECULATIVE:ROB_OTHER_WAIT_END; break;}
-                            }
-                        }
-                      else
-                        {
-                          // Have an exception : wait head of ROB
-                          
-                          // in_INSERT_NO_EXECUTE [x][y] : l.sys, l.trap
-                          
-                          entry->state = ROB_END_EXCEPTION_WAIT_HEAD;
-                        }
-                    }
-
-#ifdef STATISTICS
-                  if (usage_is_set(_usage,USE_STATISTICS))
-                    (*_stat_nb_inst_insert [x]) ++;
-#endif
-
-                  // Push in rob
-		  _rob[i].push_back(entry);
-
-		  // Update counter and pointer
-		  reg_NB_INST_COMMIT_ALL [front_end_id][context_id] ++;
-		  if (type == TYPE_MEMORY)
-		    reg_NB_INST_COMMIT_MEM [front_end_id][context_id] ++;
-
-		  reg_NUM_BANK_TAIL = (reg_NUM_BANK_TAIL+1)%_param->_nb_bank;
-		  reg_BANK_PTR [i]  = (reg_BANK_PTR [i]+1)%_param->_size_bank;
-		}
-	    }
+            }
+          // Update pointer
+          reg_NUM_BANK_TAIL = (reg_NUM_BANK_TAIL+nb_insert)%_param->_nb_bank;
+        }
 
 	// ===================================================================
@@ -255,12 +333,17 @@
 #endif
 
+        // For each commit instruction ...
 	for (uint32_t i=0; i<_param->_nb_bank; i++)
 	  for (uint32_t j=0; j<_param->_nb_bank_access_commit; j++)
+            // ... test if an instruction have finish this execution
 	    if (internal_BANK_COMMIT_VAL [i][j])
 	      {
-                // An instruction is executed. Change state of this instruction
-
+                // An instruction is executed -> Change state of this instruction
+
+                // Get information
 		uint32_t x = internal_BANK_COMMIT_NUM_INST [i][j];
 
+                // Test if instruction is valid and is enable
+                // (can be disable if this instruction is reexecute)
 		if (PORT_READ(in_COMMIT_VAL [x]) and PORT_READ(in_COMMIT_WEN [x]))
 		  {
@@ -278,5 +361,12 @@
                                                  
 		  //Toperation_t    operation    = PORT_READ(in_COMMIT_OPERATION   [x]);
-		  //Ttype_t         type         = PORT_READ(in_COMMIT_TYPE        [x]);
+ 		    Ttype_t         type         = entry->type;
+		    Tcontrol_t      no_sequence  = PORT_READ(in_COMMIT_NO_SEQUENCE [x]);
+
+#if 0
+		    if ((type == TYPE_MEMORY) and no_sequence)
+		      continue;
+#endif		    
+
 		    Texception_t    exception    = PORT_READ(in_COMMIT_EXCEPTION   [x]);
 
@@ -286,14 +376,17 @@
 
 		    // change state : test exception_use
-		    //  * test if exception : exception and mask
 		    
 		    bool have_exception        = false;
                     bool have_miss_speculation = false;
 
+                    // Test if have an exception ...
 		    if (exception != EXCEPTION_NONE)
                       {
-                        // Test if the instruction is a load and is a miss speculation (load is commit, but they have an dependence with a previous store)
+                        // Test if the instruction is a load and is a miss speculation 
+                        // (load is commit, but they have an dependence with a previous store -> need restart pipeline)
+
                         have_miss_speculation  = (exception == EXCEPTION_MEMORY_MISS_SPECULATION);
 
+                        //  * Test if the exception generated can be trap by this exception
                         switch (entry->exception_use)
                           {
@@ -327,12 +420,56 @@
                       }
                    
+                    // Next state depends of previous state
                     switch (state)
                       {
-                        // Branch ...
-                      case ROB_BRANCH_WAIT_END : {state = (have_exception)?ROB_END_EXCEPTION_WAIT_HEAD:ROB_BRANCH_COMPLETE; break;}
-                        // Store KO
-                      case ROB_EVENT_WAIT_END  : {state = ROB_END_KO_SPECULATIVE; break;}
-                        // Store OK, Load and other instruction
-                      case ROB_OTHER_WAIT_END  : {state = (have_exception)?ROB_END_EXCEPTION_WAIT_HEAD:((have_miss_speculation)?ROB_END_LOAD_MISS_SPECULATIVE:ROB_END_OK_SPECULATIVE); break;}
+                        // Branch : if no exception, the branchement can be completed
+                      case ROB_BRANCH_WAIT_END : 
+                        {
+                          if (not have_exception)
+                            state = ROB_BRANCH_COMPLETE;
+                          else
+                            state = ROB_END_EXCEPTION_WAIT_HEAD;
+                          break;
+                        }
+                        // Previous event -> set state as execute
+		      case ROB_STORE_KO_WAIT_END :
+                      case ROB_EVENT_WAIT_END  : 
+                        {
+                          state = ROB_END_KO_SPECULATIVE; 
+                          break;
+                        }
+                        // No previous event - Load and other instruction
+		      case ROB_STORE_OK_WAIT_END :
+                      case ROB_OTHER_WAIT_END  : 
+                        {
+                          if (not have_exception)
+                            {
+                              if (not have_miss_speculation)
+                                state = ROB_END_OK_SPECULATIVE;
+                              else
+                                state = ROB_END_LOAD_MISS_SPECULATIVE; 
+                            }
+                          else
+                            state = ROB_END_EXCEPTION_WAIT_HEAD;
+                          break;
+                        }
+		      case ROB_STORE_WAIT_END_OK :
+			{
+			  if (not have_exception)
+			    state = ROB_STORE_OK;
+			  else
+                            state = ROB_STORE_EVENT;
+			  break;
+			}
+		      case ROB_STORE_WAIT_END_KO :
+			{
+// 			  if (not have_exception)
+			    state = ROB_STORE_KO;
+// 			  else
+//                             state = ROB_END_EXCEPTION_WAIT_HEAD; 
+			  break;
+			}
+
+
                       default :
                         {
